//  Programming Techniques
//  Lecture 2
//
//  Text file i/o
//  example 2: Series of quadrangle data using matrices

#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
using namespace std;

int n;                           // Number of quadrangles (maximum=100)

double xp1[100], yp1[100], xp2[100], yp2[100], xp3[100], yp3[100], xp4[100], yp4[100];
double s1[100], s2[100], s3[100], s4[100], perim[100], diag[100], qarea[100];

double length(double xc1, double yc1, double xc2, double yc2)
{
     double r;
     r=sqrt((xc1-xc2)*(xc1-xc2)+(yc1-yc2)*(yc1-yc2));
     return r;
}

double tarea(double a, double b, double c)
{
       double s, ar;
       s=0.5*(a+b+c);
       ar=sqrt(s*(s-a)*(s-b)*(s-c));
       return ar;
}

int vertex_coords()
{    
    ifstream qcoords("quad_vertex.txt", ios::in);  // Define input stream
    if (! qcoords) {                               // Check validity of stream
        cerr<<"\n*Error opening input file (1)*\n";
        exit (1); }
    else {                                         // Stream OK, proceed with input
        n=0;
        while (! qcoords.eof()) {                  // Read until end-of-file
            qcoords>>xp1[n]>>yp1[n]>>xp2[n]>>yp2[n]>>xp3[n]>>yp3[n]>>xp4[n]>>yp4[n];
            n++;  }
        }
    qcoords.close();                               // Disconnect & close file
  
    return n;
}

void sides()
{
      for (int k=0;k<n;k++) {
          s1[k]=length(xp4[k],yp4[k],xp1[k],yp1[k]);
          s2[k]=length(xp1[k],yp1[k],xp2[k],yp2[k]);
          s3[k]=length(xp2[k],yp2[k],xp3[k],yp3[k]);
          s4[k]=length(xp3[k],yp3[k],xp4[k],yp4[k]);                              
          diag[k]=length(xp1[k],yp1[k],xp3[k],yp3[k]);
          perim[k]=s1[k]+s2[k]+s3[k]+s4[k];
      }
}

void areas()
{
     for (int k=0;k<n;k++) {
          qarea[k]=tarea(diag[k],s2[k],s3[k]); 
          qarea[k]=qarea[k]+tarea(diag[k],s1[k],s4[k]);              
     }
}

void quad_data()
{
    ofstream qdata("quad_results.txt", ios::out);      // Define output stream
    if (! qdata) {                                     // Check validity of stream
        cerr<<"\n*Error creating output file*\n";
        exit (1); }
    else {                                             // Stream OK, proceed with output
        qdata<<fixed<<setprecision(3);
        qdata<<"\n    Perimeter    Area\n"<<endl;
        for (int k=0;k<n;k++) 
            qdata<<setw(12)<<perim[k]<<setw(12)<<qarea[k]<<endl;
         }
    qdata.close();                                     // Close output file
}

int main()
{
    n=vertex_coords();         // Read input file and determine actual number of quadrangles (n)
    cout<<"\nInput file read successfully!";
    
    sides();                   // compute lengths of sides and perimeters
    cout<<"\nSides and perimeters computed!";

    areas();                   // compute areas of quadrangles
    cout<<"\nQuadrangles areas computed!";
        
    quad_data();               // Write results to output file
    cout<<"\nOutput file written successfully!\n";    
    
    system("pause");
    return 0;
}
